local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

local Regulator = select(2,EJ_GetCreatureInfo(5,1154))
local EJName = EJ_GetEncounterInfo(1154)

do
	local data = {
		version = 2,
		key = "TheBlastFurnace",
		zone = L.zone["Blackrock Foundry"],
		category = L.zone["Blackrock Foundry"],
		--name = L.npc_BlackrockFoundry["The Blast Furnace"],
		name = EJName,
		icon = "INTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-The Blast Furnace.BLP:35:35",
		triggers = {
			scan = {76809,76806}, --76809 foreman feldspar, 76806 heart of the mountain, 
								  --76808 Heat Regulator, 76810 Furnace Engineer, 76811 Bellows Operator, 
								  --76815 Primal Elementalist, 78463 Slag Elemental, 76821 Firecaller
			encounterid = {1690},
			ejid = {1154},
		},
		onactivate = {
			tracing = {
			76809, "boss2", "boss3", "boss4","boss5",
			alternatepower={true},
			markers1 = {25,55,85},
			},
			tracerstart = true,
			combatstop = true,
			unittracing = {"boss1","boss2","boss3","boss4","boss5"},
			defeat = {76809, 76808, 76806, 76815}
		},
		windows = {
			proxwindow = true,
		},
		enrage = {
			timelfr = 780,
			timeflex = 780,
			timeheroic = 780,
			timemythic = 780,
		},
		userdata = {
			machinesDead = 0,
			elementalistsDead = 0,
			powerRate = 4,
			totalTime = 25,
			power = 100,
			powern = 100,
			warned = 0,
			newTime = 30,
			blastTime = 30,
			bombOnMe = 0,
			prev = 0,
			Bombunits = {type = "container"},
			Bombunits2 = {type = "container"},
			Fixateunits = {type = "container", wipein = 3},
			MeltArmorunits = {type = "container", wipein = 3},
			Heatunits = {type = "container", wipein = 3},
			regulatorDeaths = 0,
			shamanDeaths = 0,
			volatileFireOnMe = 0,
			volatileFireunits = {type = "container"},
			volatileFireunits2 = {type = "container"},
			engineerFireunits = {type = "container"},
		},
		timers = {
			timerRadar = {
				{
					"expect",{"&count|volatileFireunits2&",">","0"},
					"openwindow",{"9","&list|volatileFireunits2&",true},
				},
				{
					"expect",{"&count|Bombunits2&",">","0"},
					"openwindow",{"9","&list|Bombunits2&",true},
				},
				{
					"expect",{"<volatileFireOnMe>","==","1"},
					"openwindow",{"9"},
				},
				{
					"expect",{"<bombOnMe>","==","1"},
					"openwindow",{"9"},
				},				
			},
			timerPower = {
				{
					"set",{power = "&getap|boss1&"},
					"set",{newTime = 30},
					"invoke",{
						{
							"expect",{"<power>","==","100"},
							"set",{newTime = 6},
						},					
						{
							"expect",{"<power>",">","74"},
							"set",{newTime = 9},
						},
						{
							"expect",{"<power>",">","49"},
							"set",{newTime = 15},
						},
						{
							"expect",{"<power>",">","24"},
							"set",{newTime = 20},
						},
						{
							"expect",{"<newTime>","~=","<blastTime>"},
							"set",{blastTime = "&checkPower|boss1|<newTime>&"},
							"set",{newTime = "<blastTime>"},
							"alert",{"BlastCD", time = 4},
						},	
					},
				},
				{
					"set",{powern = "&getup|boss1&"},
					"invoke",{
						{
							"expect",{"<powern>",">","80"},
							"expect",{"<powern>",">","100"},
							"set",{warned = 1},
							"invoke",{
								{
									"expect",{"<blastTime>",">","10"},
									"message","mBlast",
								},
							},
						},	
						{
							"expect",{"<powern> <warned>","==","0 1"},
							"set",{warned = 0},
							"alert",{"BlastCD", time = 4},
						},							
					},
				},
				{
					"scheduletimer",{"timerPower",1},
				},
			},
			timerBomb = {
				{
					"message","mBomb",
				},
			},
			timerVolatileFire = {
				{
					"message","mVolatileFire",
				},
			},			
			timerFixate = {
				{
					"message","mFixate",
				},
			},
			timerMeltArmor = {
				{
					"message","mMeltArmor",
				},
			},	
			timerHeat = {
				{
					"message","mHeat",
				},
			},			
		},	
		announces = { 
			Bombsay = {
				varname = format(L.alert["%s %s %s!"],SN[155192],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[155192],L.alert["on"],L.alert["Me"]),
				desc = 155192,
				icon = ST[155192],
				--flashcolor = "RED",
				--flashscreen = true,
			},
			VolatileFiresay = {
				varname = format(L.alert["%s %s %s!"],SN[176121],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[176121],L.alert["on"],L.alert["Me"]),
				desc = 176121,
				icon = ST[176121],
				exlfr = true,
			},
			Rupturesay = {
				varname = format(L.alert["%s %s %s!"],SN[156934],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[156934],L.alert["on"],L.alert["Me"]),
				desc = 156934,
				icon = ST[156934],
			},	
			Meltsay = {
				varname = format(L.alert["%s %s %s!"],SN[155225],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[155225],L.alert["on"],L.alert["Me"]),
				desc = 155225,
				icon = ST[155225],
			},				
		},
		messages = {
			mHeat = {
				varname = format(L.alert["%s %s %s"],SN[155242],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|Heatunits&"],SN[155242],L.alert["on"]),
				color1 = "TAN",
				sound = "ALERT13",
				desc = 155242,
				icon = ST[155242],
			},			
			mMeltArmor = {
				varname = format(L.alert["%s %s %s"],SN[175104],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|MeltArmorunits&"],SN[175104],L.alert["on"]),
				color1 = "TAN",
				sound = "ALERT13",
				desc = 175104,
				icon = ST[175104],
			},		
			mBomb = {
				varname = format(L.alert["%s %s %s"],SN[155192],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|Bombunits&"],SN[155192],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 155192,
				icon = ST[155192],
			},
			mVolatileFire = {
				varname = format(L.alert["%s %s %s"],SN[176121],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|volatileFireunits&"],SN[176121],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 176121,
				icon = ST[176121],
			},			
			mFixate = {
				varname = format(L.alert["%s %s %s"],SN[155196],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|Fixateunits&"],SN[155196],L.alert["on"]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 155196,
				icon = ST[155196],
			},			
			mBellowsOperator = {
				varname = format(L.alert["%s!"],SN["ej9650"]),
				type = "message",
				text = format(L.alert["%s!"],SN["ej9650"]),
				color1 = "RED",
				sound = "ALERT13",
				ability = 9650,
				icon = ST[155181],
			},	
			mSuperheated = {
				varname = format(L.alert["%s!"],SN[163776]),
				type = "message",
				text = format(L.alert["%s!"],SN[163776]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 163776,
				icon = ST[163776],
			},	
			mRegulatorDeaths = {
				varname = format(L.alert["%s (2/2)"],Regulator),
				type = "message",
				text = format(L.alert["#5# (<regulatorDeaths>/2)"]),
				color1 = "ORANGE",
				sound = "ALERT13",
				--desc = 163776,
				icon = ST[163776],
			},	
			mShamanDeaths = {
				varname = format(L.alert["%s (2/4)"],L.npc_BlackrockFoundry["Heat Regulator"]),
				type = "message",
				text = format(L.alert["#5# (<shamanDeaths>/4)"]),
				color1 = "ORANGE",
				sound = "ALERT13",
				--desc = 163776,
				icon = ST[163776],
			},
			mBlast = {
				varname = format(L.alert["%s %s!"],SN[155209],L.alert["soon"]),
				type = "message",
				text = format(L.alert["%s %s!"],SN[155209],L.alert["soon"]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 155209,
				icon = ST[155209],
				extank = true,
				exhealer = true,
			},					
		},
		onstart = {
			{
			--	"expect",{"&lfr&","==","true"},
				"alert",{"BlastCD", time = 4},
				"set",{powerRate = 3.33},
				"set",{totalTime = 30},
				"scheduletimer",{"timerPower",1},
		--	},
			--{
			--	"expect",{"&lfr&","==","false"},
			--	"alert",{"BlastCD", time = 3},
			},
		},
		alerts = {
			BlastCD = {
				varname = format(L.alert["%s Cooldown"],SN[155209]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[155209]),
				time = 57,
				time2 = 30,
				time3 = 25,
				time4 = "<blastTime>",
				color1 = "NEWBLUE",
				icon = ST[155209],
				desc = 155209,		
			},
			NextEngineer = {
				varname = format(L.alert["Next %s"],SN["ej9649"]),
				type = "dropdown",
				text = format(L.alert["Next %s"],SN["ej9649"]),
				time = 35,
				color1 = "NEWBLUE",
				icon = ST[155179],
				ability = 9649,		
			},	
			NextBellowsOperator = {
				varname = format(L.alert["Next %s"],SN["ej9655"]),
				type = "dropdown",
				text = format(L.alert["Next %s"],SN["ej9655"]),
				time = 64,
				color1 = "NEWBLUE",
				icon = ST[155181],
				ability = 9655,		
				throttle = 5,
			},				
			-- Warning
			Phase2 = {
				varname = format(L.alert["Phase 2"]),
				type = "simple",
				text = format(L.alert["Phase 2"]),
				time = 2,
				color1 = "YELLOW",
				icon = EJST[9650],
				sound = "ALERT13",
			},
			wRepair = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[155179]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[155179]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[155179],
				sound = "ALERT10",
				desc = 155179,
				exhealer = true,
			},
			wSlagBomb = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[176133]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[176133]),
				time = 2,
				color1 = "YELLOW",
				icon = ST[176133],
				sound = "ALERT10",
				desc = 176133,
			},
			wPyroclasm = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[156937]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[156937]),
				time = 2,
				color1 = "RED",
				icon = ST[156937],
				sound = "ALERT11",
				desc = 156937,
			},			
			wCauterizeWounds = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[155186]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[155186]),
				time = 2,
				color1 = "RED",
				icon = ST[155186],
				sound = "ALERT10",
				desc = 155186,
			},			
			-- Inform
			iReactiveEarthShield = {
				varname = format(L.alert["%s %s %s %s!"],L.alert["Dispell"],SN[155173],L.alert["on"],L.alert["Boss"]),
				type = "inform",
				text = format(L.alert["%s %s %s #5#!"],L.alert["Dispell"],SN[155173],L.alert["on"]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[155173],
				sound = "ALERT13",
				desc = 155173,
			},			
			iBomb = {
				varname = format(L.alert["%s %s %s, %s!"],SN[155192],L.alert["on"],L.alert["YOU"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s %s, %s!"],SN[155192],L.alert["on"],L.alert["YOU"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[155192],
				sound = "ALERT12",
				desc = 155192,
				flashscreen = true,
			},
			iVolatileFire = {
				varname = format(L.alert["%s %s %s, %s!"],SN[176121],L.alert["on"],L.alert["YOU"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s %s, %s!"],SN[176121],L.alert["on"],L.alert["YOU"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[176121],
				sound = "ALERT12",
				desc = 176121,
				flashscreen = true,
			},			
			iFixate = {
				varname = format(L.alert["%s %s %s!"],SN[155196],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[155196],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "RED",
				icon = ST[155196],
				sound = "ALERT11",
				desc = 155196,
				flashscreen = true,
			},	
			iMelt = {
				varname = format(L.alert["%s %s %s!"],SN[155225],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[155225],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "NEWBLUE",
				icon = ST[155225],
				sound = "ALERT10",
				desc = 155225,
				flashscreen = true,
			},
			iMeltUnder = {
				varname = format(L.alert["%s %s, %s!"],SN[155225],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[155225],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "NEWBLUE",
				icon = ST[155225],
				sound = "ALERT12",
				desc = 155225,
				flashscreen = true,
				throttle = 2,
			},	
			iRupture = {
				varname = format(L.alert["%s %s %s!"],SN[156934],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[156934],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "YELLOW",
				icon = ST[156934],
				sound = "ALERT10",
				desc = 156934,
				flashscreen = true,
			},
			iRuptureUnder = {
				varname = format(L.alert["%s %s, %s!"],SN[156934],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[156934],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[156934],
				sound = "ALERT12",
				desc = 156934,
				flashscreen = true,
				throttle = 2,
			},				
			iShieldsDown = {
				varname = format(L.alert["%s %s!"],SN["ej9655"],L.alert["SWITCH TARGET"]),
				type = "inform",
				text = format(L.alert["%s %s!"],SN["ej9655"],L.alert["SWITCH TARGET"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT11",                
				icon = EJST[9655],
				ability = 9655,
				exhealer = true,
				extank = true,
				throttle = 10,
			},	
			--[[iBellowsOperator = {
				varname = format(L.alert["%s %s!"],SN["ej9650"],L.alert["SWITCH TARGET"]),
				type = "inform",
				text = format(L.alert["%s %s!"],SN["ej9650"],L.alert["SWITCH TARGET"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT11",                
				icon = EJST[9650],
				ability = 9650,
				exhealer = true,
				throttle = 10,
			},	--]]
			iHeartoftheMountain = {
				varname = format(L.alert["%s %s!"],SN["ej10808"],L.alert["SWITCH TARGET"]),
				type = "inform",
				text = format(L.alert["%s %s!"],SN["ej10808"],L.alert["SWITCH TARGET"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT11",                
				icon = EJST[10808],
				ability = 10808,
				exhealer = true,
				exdps = true,
			},				
			-- Casts
			ShieldsDownActive = {
				varname = format(L.alert["%s Active"],SN[158345]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[158345]),
				time = 30,
				time2 = 40,
				color1 = "NEWBLUE",
				icon = ST[158345],
				desc = 158345,
				exhealer = true,
				extank = true,
				throttle = 10,
			},
			MeltActive = {
				varname = format(L.alert["%s Active"],SN[155225]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[155225]),
				time = 10,
				color1 = "BROWN",
				icon = ST[155225],
				desc = 155225,
			},			
			RuptureActive = {
				varname = format(L.alert["%s Active"],SN[156934]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[156934]),
				time = 5,
				color1 = "YELLOW",
				icon = ST[156934],
				desc = 156934,
			},			
			BombActive = {
				varname = format(L.alert["%s Duration"],SN[155192]),
				type = "centerpopup",
				text = format(L.alert["%s Duration"],SN[155192]),
				time = 15,
				color1 = "RED",
				icon = ST[155192],
				desc = 155192,
			},
			VolatileFireActive = {
				varname = format(L.alert["%s Duration"],SN[176121]),
				type = "centerpopup",
				text = format(L.alert["%s Duration"],SN[176121]),
				time = 8,
				color1 = "ORANGE",
				icon = ST[176121],
				desc = 176121,
			},			
			-- Debuff
			BombDebuff = {
				varname = format(L.alert["%s Debuff"],SN[155192]),
				type = "debuff",
				text = format(L.alert["%s: %s"],L.alert["YOU"],SN[155192]),
				text2 = format(L.alert["#5#: %s"],SN[155192]),
				time = 15,
				color1 = "PURPLE",
				desc = 155192,
				icon = ST[155192],
				tag = "#5#",
				exdps = true,				
			},	
			VolatileFireDebuff = {
				varname = format(L.alert["%s Debuff"],SN[176121]),
				type = "debuff",
				text = format(L.alert["%s: %s"],L.alert["YOU"],SN[176121]),
				text2 = format(L.alert["#5#: %s"],SN[176121]),
				time = 8,
				color1 = "RED",
				desc = 176121,
				icon = ST[176121],
				tag = "#5#",
				exdps = true,				
			},
			--[[MeltArmorDebuff = {
				varname = format(L.alert["%s Debuff"],SN[175104]),
				type = "debuff",
				text = format(L.alert["%s (1): %s"],L.alert["YOU"],SN[175104]),
				text2 = format(L.alert["#5# (1): %s"],SN[175104]),
				text3 = format(L.alert["%s (#11#): %s"],L.alert["YOU"],SN[175104]),
				text4 = format(L.alert["#5# (#11#): %s"],SN[175104]),
				time = 10,
				color1 = "TAN",
				desc = 175104,
				icon = ST[175104],
				tag = "#5#",
				exdps = true,				
			},--]]	
			HeatDebuff = {
				varname = format(L.alert["%s Debuff"],SN[155242]),
				type = "debuff",
				text = format(L.alert["%s (1): %s"],L.alert["YOU"],SN[155242]),
				text2 = format(L.alert["#5# (1): %s"],SN[155242]),
				text3 = format(L.alert["%s (#11#): %s"],L.alert["YOU"],SN[155242]),
				text4 = format(L.alert["#5# (#11#): %s"],SN[155242]),
				time = 10,
				color1 = "ORANGE",
				desc = 155242,
				icon = ST[155242],
				tag = "#5#",
				exdps = true,				
			},				
		},
		events = {
			-- Bomb 
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {155192, 174716},
				execute = {
					{
						"insert",{"Bombunits","#5#"},
						"insert",{"Bombunits2","#5#",true},
						"canceltimer","timerBomb",
						"scheduletimer",{"timerBomb",0.5},							
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"batchalert",{"BombActive","BombDebuff","iBomb"},
						"announce","Bombsay",
						"set",{bombOnMe = 1},
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"BombDebuff", text = 2},
					},
					{
						"scheduletimer",{"timerRadar",0.1},
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {155192, 174716},
				execute = {
					{
						"delete",{"Bombunits","#5#"},
						"delete",{"Bombunits2","#5#"},
						"quash","BombDebuff"
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"quash","BombActive",
						"set",{bombOnMe = 0},
						"closewindow",
					},
					{
						"expect",{"&count|Bombunits&","==","0"},
						"closewindow",
					},
					{
						"scheduletimer",{"timerRadar",0.1},
					},
				},
			},				
			-- ShieldsDown 
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {158345},
				execute = {
					{
						"alert","iShieldsDown",
					},			
					{
						"expect",{"&flex&","==","true"},
						"alert","ShieldsDownActive",
					},
					{
						"expect",{"&flex&","~=","true"},
						"alert",{"ShieldsDownActive", time = 2},
					},							
				},
			},
			-- Repair
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {155179},
				execute = {
					{
						"alert","wRepair",
					},			
				},
			},	
			-- BellowsOperator Loading
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {155181},
				execute = {
					{
						--"batchalert",{"NextBellowsOperator","iBellowsOperator"}
						"expect",{"&getprev|<prev>&",">","5"},
						"set",{prev = "&gettime&"},
						"alert","NextBellowsOperator",
						"message","mBellowsOperator",
					},
				},
			},	
			-- Fixate
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {155196},
				--dstisplayerunit = true,
				execute = {
					{
						"insert",{"Fixateunits","#5#"},
						"canceltimer","timerFixate",
						"scheduletimer",{"timerFixate",1},							
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","iFixate",
					},				
				},
			},	
			-- SlagBomb
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {176133},
				execute = {
					{
						"alert","wSlagBomb",
					},			
				},
			},
			-- ReactiveEarthShield
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {155173},
				execute = {
					{
						"expect",{"&npcid|#4#& &ismagicdispeller&","==","76815 true"},
						"alert","iReactiveEarthShield",
					},
		
				},
			},
			-- CauterizeWounds
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {155186},
				execute = {
					{
						"alert","wCauterizeWounds",
					},			
				},
			},		
			-- VolatileFire 
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {176121},
				execute = {
					{
						"expect",{"&contains|volatileFireunits|#5#&","==","false"},
						"insert",{"volatileFireunits","#5#"},
						"insert",{"volatileFireunits2","#5#",true},
						"canceltimer","timerVolatileFire",
						"scheduletimer",{"timerVolatileFire",0.5},							
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"batchalert",{"VolatileFireActive","VolatileFireDebuff","iVolatileFire"},
						"announce","VolatileFiresay",
						"set",{volatileFireOnMe = 1},
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"VolatileFireDebuff", text = 2},
					},
					{
						"scheduletimer",{"timerRadar",0.1},
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {176121},
				execute = {
					{
						"delete",{"volatileFireunits","#5#"},
						"delete",{"volatileFireunits2","#5#"},
						"quash","VolatileFireDebuff"
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"quash","VolatileFireActive",
						"set",{volatileFireOnMe = 0},
						"closewindow",
					},
					{
						"expect",{"&count|volatileFireunits&","==","0"},
						"closewindow",
					},
					{
						"scheduletimer",{"timerRadar",0.1},
					},
				},
			},		
			-- Pyroclasm
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {156937},
				execute = {
					{
						"alert","wPyroclasm",
					},			
				},
			},	
			-- MeltArmor 
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {175104},
				execute = {
					{
						"insert",{"MeltArmorunits","#5#"},
						"canceltimer","timerMeltArmor",
						"scheduletimer",{"timerMeltArmor",0.5},							
					},
					--[[{
						"expect",{"#4#","==","&playerguid&"},
						"alert","MeltArmorDebuff",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"MeltArmorDebuff", text = 2},
					},--]]
				},
			},
		--[[	{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {175104},
				execute = {
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert",{"MeltArmorDebuff", text = 3},
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"MeltArmorDebuff", text = 4},
					},
				},
			},--]]
			-- Rupture 
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {156934},
				dstisplayerunit = true,
				execute = {
					{
						"batchalert",{"iRupture","RuptureActive"},
						"announce","Rupturesay",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {156932},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iRuptureUnder",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {156932},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iRuptureUnder",
					},
				},
			},
			-- Heat 
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {155242},
				execute = {
					{
						"insert",{"Heatunits","#5#"},
						"canceltimer","timerHeat",
						"scheduletimer",{"timerHeat",0.5},							
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","HeatDebuff",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"HeatDebuff", text = 2},
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {155242},
				execute = {
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert",{"HeatDebuff", text = 3},
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"HeatDebuff", text = 4},
					},
				},
			},
			-- Melt 
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {155225},
				dstisplayerunit = true,
				execute = {
					{
						"batchalert",{"iMelt","MeltActive"},
						"announce","Meltsay",					
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {155223},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iMeltUnder",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {155223},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iMeltUnder",
					},
				},
			},
			-- Superheated 
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {163776},
				execute = {
					{
						"message","mSuperheated",
						"set",{newTime = 6},
					},
					{
						"expect",{"<newTime>","~=","<blastTime>"},
						"set",{blastTime = "&checkPower|boss1|<newTime>&"},
						"set",{newTime = "<blastTime>"},
						"alert",{"BlastCD", time = 4},
					},						
				},
			},
			
			-----
			{
				type = "combatevent",
				eventtype = "UNIT_DIED",
				execute = {
					{
						"expect",{"&npcid|#4#&","==","76808"}, --regulator
						"set",{regulatorDeaths = "INCR|1"},
						"message","mRegulatorDeaths",
						"invoke",{
							{
								"expect",{"<regulatorDeaths>",">","1"},
								"quash","NextBellowsOperator",
							},
						},
					},					
					{
						"expect",{"&npcid|#4#&","==","76815"}, -- Shaman
						"set",{shamanDeaths = "INCR|1"},
						"message","mShamanDeaths",
						"invoke",{
							{
								"expect",{"<shamanDeaths>",">","3"},
								"alert","Phase2",
								--"batchquash",{"NextEngineer","NextBellowsOperator"},
							},
						},
					},
					{
						"expect",{"&npcid|#4#&","==","76809"}, -- foreman feldspar
						"tracing",{77428,"boss2","boss3"},
					},						
				},
			},			
		},
	}

	DXE:RegisterEncounter(data)
end